﻿main();

function swapPages(p0, p1)
{
  if (p0 == p1) return true;
  var pages = app.activeDocument.pages;
  var pg0 = pages.itemByName(''+p0); // force string argument
  var pg1 = pages.itemByName(''+p1); // force string argument

  if ( pg0.documentOffset > pg1.documentOffset )
    return swapPages(p1,p0);

  try {
  pg1.move(LocationOptions.AFTER,pg0);
  pg0.move(LocationOptions.AFTER,pages.itemByName(''+p1));
  return true;
  }
  catch(ex) {return false;}
}

// usage:

function main()
{
  var myDoc = app.activeDocument;
  var myList;
  myList = myDoc.pages.everyItem().name;

  var myDialog = app.dialogs.add({name:"SwapPages",
    canCancel:true});
  with(myDialog){
  //Add a dialog column.
  with(dialogColumns.add()){
    with (dialogColumns.add()) {
      staticTexts.add({
        staticLabel: "swap page "
        });
      }
    with (dialogColumns.add()) {
      //Create a pop-up menu ("dropdown") control.
      var myPageDropdown0 = dropdowns.add({
        stringList: myList,
        selectedIndex: 0
        });
      }
    with (dialogColumns.add()) {
      staticTexts.add({
        staticLabel: " with page "
        });
      }
    with (dialogColumns.add()) {
      //Create a pop-up menu ("dropdown") control.
      var myPageDropdown1 = dropdowns.add({
        stringList: myList,
        selectedIndex: 0
        });
      }
    }
  }

  if(myDialog.show() == true){
    swapPages(myList[myPageDropdown0.selectedIndex],
      myList[myPageDropdown1.selectedIndex]);
    myDialog.destroy();
  }
  else{
    myDialog.destroy();
  }
}